<?php
/**
 * @package		Joomla Bamboo Zen Grid Framework
 * @Type        Core Framework Files
 * @version		v1.0
 * @author		Joomal Bamboo http://www.joomlabamboo.com
 * @copyright 	Copyright (C) 2007 - 2010 Joomla Bamboo
 * @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted index access' );


/**
 * Renders a editors element
 *
 * @package 	Joomla.Framework
 * @subpackage		Form
 * @since		1.6
 */

class JFormFieldCheckfile extends JFormField
{
	/**
	* Element name
	*
	* @access	protected
	* @var		string
	*/
	
	protected $type = 'checkfile';

	protected function getInput()
	{
	}
	
	public function getLabel() {
		$label     = (string) $this->element['label'];
		
		// Get module id
		$id =  $_SERVER['REQUEST_URI'];
		
		// Split all up until the id fragment
		$id = explode('id=', $id);
		
		// Make sure nothing comes after that
		if(isset($id[1])) {
			// Make sure nothing comes after that
			$id = explode('&', $id[1]);
			
			// This is the id
			$id = $id[0];
		} else {
			$id = 0;
		}
				
		// Check to see if custom css file exists for this module
		$custom_css = 0;
		
		$check_path = JPATH_ROOT . '/media/mod_zentools2/css/custom/zentools-'.$id.'.min.css';
		
		if(file_exists($check_path)) {
		
			return '<p id="checkfile" class="uk-alert uk-success">Custom file exists for this module. <br />Click the create custom css button below to update it based on current settings.</p>';
			
		} else {
		
			return '<p id="checkfile" class="uk-alert uk-notice">Custom file not yet created. <br />Click the Create custom css button below to create a css file that can be used to specifically target this module.</p>';
		}
		
	}

}
?>