<?php defined('JPATH_PLATFORM') or die;

class JFormFieldZenLayout extends JFormField
{

	public $type = 'Zenlayout';

	// Stores the options available for each layout
	// Displays the layouts

	protected function getInput()
	{
		// Initialize variables.
		jimport('joomla.filesystem.folder');
		$path	= JPATH_ROOT.'/modules/mod_zentools2/settings/layouts/';
		$files = JFolder::files($path,'', false, false ); ?>
		
		<!-- layout selector -->
		<div class="zt-admin">
			<div id="layouts">
				<h3 class="zt-title" id="layout-title">Select a layout <span id="zt-current-layout"></span></h3>
				<ul id="zt-layout-list" class="zt-toggle">
				<?php foreach ($files as $key => $layout)
				{ 
					// Get the layouts available
					$layout = JFile::stripExt($layout); 
					$name = ucfirst(str_replace('-', ' ', $layout)); 
					
					// List layout items for this layout
							// eg navigation elements for carousel, slideshow etc 
							// 
							$items = JFactory::getXML($path . $layout . '.xml'); 
							$image_path = '../modules/mod_zentools2/admin/images/icons/';
							if(isset($items['icon'])) {
								$icon = $image_path . $items['icon'];
							} else {
								$icon = $image_path . 'blank.gif';
							}
							?>
					
					<li class="zt-layout-item" data-name="<?php echo $name;?>" data-id="<?php echo $layout;?>">
					<a href="">
						<img src="<?php echo $icon;?>" alt="<?php echo $icon;?>" />
					<span class="uk-badge uk-badge-notification">
							<?php echo $layout;?></span></a>
					</li>
					
					
					<?php  	?>
						
				
							<li>
								<ul class="zt-item-list zt-hide" id="<?php echo $layout;?>-items">
									<?php foreach ($items->children() as $key => $elements) { 
										
									?>
										<?php foreach ($elements as $key => $item) { ?><li class="connectable" data-type="<?php echo $key; ?>"><span class="<?php echo $item['icon'];?>"></span></li><?php } ?>
									<?php } ?>
								</ul>
							</li>
						
						
					<?php 
						// List the hotspots for this display
						// eg left, right, bottom, top etc.
						
					?>
					<li>
						<ul  class="zt-hide" id="<?php echo $layout;?>-layout">
							<?php foreach ($items->children()->layout as $key => $items) {  ?>
								<?php foreach ($items as $key => $item) { 
							
								?><li class="connectable" data-display="<?php echo $item['type'];?>" data-type="<?php echo $key; ?>"><?php echo $item?></li><?php } ?>
							<?php } ?>
						</ul>
					</li>
					<?php }	?>
				</ul>
			</div>
		</div>
	<?php }
	
	function getLabel()
	{
		return '';
	}
}						