<?php
/**
 * @package		Zen Tools
 * @subpackage	Zen Tools
 * @author		Joomla Bamboo - design@joomlabamboo.com
 * @copyright 	Copyright (c) 2014 Copyright (C), Joomlabamboo. All Rights Reserved.. All rights reserved.
 * @license		Copyright Joomlabamboo 2014
 * @version		1.11.5
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.filesystem.file');

class ZenTools2Helper
{
	/**
	* 	Returns true for using image as a source
	*	We do this because images are automatically available
	* 	As a source
	*/
	
	
	public function __construct()
	{
			$this->_doc =JFactory::getDocument();
			$this->media_path = JURI::BASE().'media/mod_zentools2/';
			
			$this->_siteApp = JFactory::getApplication( 'site' );
			$this->_template = $this->_siteApp->getTemplate();
			
	}	
	
	
	
	/**
	 * Returns a json decoded object
	 *
	 * 
	 */
	
	
	public function get_json($path) {
		$settings = Jfile::Read($path);
		return json_decode($settings);
	}
	
	
	
	/**
	 * Loads elements
	 *
	 * 
	 */
	 
	public function loadElement($type, $element, $item, $settings, $zen) {
		
		// Check to see if override exists
		$override = JPATH_ROOT .'/templates/'.$this->_template.'/html/mod_zentools2/elements/'.$type.'.php';


		if(jfile::exists($override)) {
			$path = $override;
		} else {
			$path = JPATH_ROOT .'/modules/mod_zentools2/tmpl/elements/'.$type.'.php';
		}
			
		if(file_exists($path)) {
			include($path);
		}
		else {
			echo $type . ' element not found.<br />';
		}
	}
	
	
	
	/**
	 * Loads blocks
	 *
	 * 
	 */
	 
	public function loadBlock($type, $module, $settings = null, $images = null) {

		// Check to see if override exists
		$override = JPATH_ROOT .'/templates/'.$this->_template.'/html/mod_zentools2/blocks/'.$type.'.php';
	
		if(jfile::exists($override)) {
		
			$path = $override;
		
		} else {
		
			$path = JPATH_ROOT .'/modules/mod_zentools2/tmpl/blocks/'.$type.'.php';
		
		}
				
		if(file_exists($path)) {
			include($path);
		}
		else {
			echo $type . ' block not found.<br />';
		}
	}
	
	
	
	
	/**
	 * 	Loads a js or css file
	 *	Used to load custom.css
	 *
	 */
	
	
	public function load_assets($layout) {
		
		// Check exists
		$layout = JPATH_ROOT .'/modules/mod_zentools2/settings/layouts/'. $layout .'.xml';
		
		
	
		if (file_exists($layout)) {
		
			$assets = JFactory::getXML($layout);
			$assets = $assets->assets;
			
			$items = array();
			
			foreach ($assets[0] as $key => $asset) {
				$items[] = $asset;	
			}
			
			return $items;
		}
	}
	

		
		
	/**
	* 	Checks if Com Ajax is installed
	*	Required for the module admin
	* 	
	*/
	
	public static function com_ajax()
		{
			jimport( 'joomla.filesystem.file' );
	
			if(JFile::exists(JPATH_ADMINISTRATOR . '/components/com_ajax/ajax.php')) {
				return 1;
			} else {
				return 0;
			}
	}

		
		
	/**
	* 	Returns true for using Image as a source
	*	We do this because Images are automatically available
	* 	as a source
	*/		
		
	public static function images() {
			return true;	
	}
	
	
	/**
	* 	Returns true for using Joomla as a source
	*	We do this because Joomla is automatically available
	* 	as a source
	*/
	
	public static function joomla() {
			return true;	
	}
	
	
	
	/**
	* 	Returns true for using Joomla banners as a source
	*	We do this because Joomla is automatically available
	* 	as a source
	*/
	
	public static function joomla_banners() {
			return true;	
	}


	/**
	* 	Returns true for using Joomla banners as a source
	*	We do this because Joomla is automatically available
	* 	as a source
	*/
	
	public static function joomla_contacts() {
			return true;	
	}
	
	
	/**
	* 	Returns true for using Joomla banners as a source
	*	We do this because Joomla is automatically available
	* 	as a source
	*/
	
	public static function joomla_categories() {
			return true;	
	}
	
	
	
	/**
	* 	Returns true for using Joomla banners as a source
	*	We do this because Joomla is automatically available
	* 	as a source
	*/
	
	public static function joomla_tags() {
			return true;	
	}
	
	
	/**
	* 	Returns true if K2 is installed
	*/
	
	public static function k2_authors() {
			return self::k2();	
	}
		
	/**
	* 	Returns true if K2 is installed
	*/	
	public static function k2_categories() {
			return self::k2();	
	}
	
	
	/**
	* 	Checks if Hikashop is installed
	*	Required for the module admin
	* 	
	*/
	
	public static function zt_hikashop()
		{
			jimport( 'joomla.filesystem.file' );
	
			if(JFile::exists(JPATH_ADMINISTRATOR . '/components/com_hikashop/hikashop.php')) {
				return 1;
			} else {
				return 0;
			}
	}
	
	/**
	* 	Renders fields for display in admin
	*	
	* 	
	*/
	public function render($type,$description,$label,$options, $name,$class, $value, $tag, $compile,$target,$folder,$show_empty)
	{
	   	$path = JPATH_ROOT . '/modules/mod_zentools2/admin/fields/'.$type.'.php';
		
		if(file_exists($path)) {
	   		include($path);
	   	}
	}
	
	
	
	/**
	* 	Checks if K2 is installed
	*
	* 
	*/
	
	public static function k2()
	{
		jimport( 'joomla.filesystem.file' );

		if (defined('K2_JVERSION'))
		{
			return true;
		}

		return JFile::exists(JPATH_ADMINISTRATOR . '/components/com_k2/k2.php');
	}
	
	
	
	/**
	* 	Checks if Easyblog is installed
	*
	* 
	*/
	
	public static function easyblog()
		{
			jimport( 'joomla.filesystem.file' );
	
			if(JFile::exists(JPATH_ADMINISTRATOR . '/components/com_easyblog/easyblog.php')) {
				return 1;
			} else {
				return 0;
			}
			
	}



	/**
	* 	Checks if Gallery option is available
	*
	* 
	*/
	
	public static function gallery()
		{
			jimport( 'joomla.filesystem.file' );
	
			if(JFile::exists(JPATH_SITE . '/modules/mod_zentools2/gallery/gallery-default.json')) {
				return 1;
			} else {
				return 0;
			}
			
	}
		
	
	
	
	
	public static function removeBasePath($path)
		{
			$basePath = JPATH_SITE . '/';
	
			if (empty($basePath))
			{
				$basePath = dirname($_SERVER['SCRIPT_FILENAME']);
			}
	
			return str_replace($basePath, '', $path);
	}
	
	
	
	public static function getResizedImage($image, $width, $height, $option)
	{
		return self::removeBasePath(ZenToolsResizeImageHelper::getResizedImage($image, $width, $height, $option));
	}




	public static function handleRemoteImage($image)
	{
		jimport('joomla.filesystem.path');
		jimport('joomla.filesystem.file');

		// Check if it is a remote image
		if ((bool)preg_match('/^http/i', $image))
		{
			// Import libraries
			jimport('joomla.filesystem.folder');

			$ext = pathinfo($image, PATHINFO_EXTENSION);

			$cacheFolder = JPath::clean(JPATH_ROOT . '/media/mod_zentools/cache/images/');
			$dest = $cacheFolder . 'remote-image-' . md5($image) . '.' . $ext;

			if (!JFolder::exists($cacheFolder))
			{
				JFolder::create($cacheFolder);
			}

			if (!JFile::exists($dest) || filesize($dest) === 0)
			{
				// Check if the allow_url_open is enabled
				if ((bool)ini_get('allow_url_fopen'))
				{
					$image = str_replace('http:/w', 'http://w', $image);
					file_put_contents($dest, file_get_contents($image));
				}
				// Check if cUrl is enabled
				else if (in_array('curl', get_loaded_extensions()))
				{
					$fp = fopen($dest, 'wb');

					$curl = curl_init($image);
					curl_setopt($curl, CURLOPT_HEADER, false);
    				curl_setopt($curl, CURLOPT_BINARYTRANSFER, 1);
					curl_setopt($curl, CURLOPT_FILE, $fp);
					curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
					curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
					curl_exec($curl);
					curl_close($curl);

					fclose($fp);
				}
			}

			// Check if the cached file exists
			if (JFile::exists($dest))
			{
				$image = str_replace(JPATH_ROOT . DIRECTORY_SEPARATOR, '', $dest);
			}
		}

		return $image;
	}


	/**
		* This is a better truncate implementation than what we
		* currently have available in the library. In particular,
		* on index.php/Banners/Banners/site-map.html JHtml's truncate
		* method would only return "Article...". This implementation
		* was taken directly from the Stack Overflow thread referenced
		* below. It was then modified to return a string rather than
		* print out the output and made to use the relevant JString
		* methods. Now, modified to work with utf-8 chars.
		*
		* @link http://stackoverflow.com/questions/1193500/php-truncate-html-ignoring-tags
		* @param mixed $html
		* @param mixed $maxLength
		*/
		public static function truncate($html, $maxLength = 0, $suffixChar='&hellip;', $wholeword = 0)
		{
			$printedLength = 0;
			$position = 0;
			$tags = array();
			$suffix = '';
			$output = '';
	
			if((mb_strlen($html)) > ($maxLength+1)){
				$suffix = $suffixChar;
			}
	
			if (empty($html)) {
				return $output;
			}
	
			while ($printedLength < $maxLength && ZenTools2Helper::mb_preg_match('{</?([a-z]+)[^>]*>|&#?[a-zA-Z0-9]+;}', $html, $match, PREG_OFFSET_CAPTURE, $position))
			{
				list($tag, $tagPosition) = $match[0];
	
				// Print text leading up to the tag.
				$str = mb_substr($html, $position, $tagPosition - $position);
				
				if ($printedLength + mb_strlen($str) > $maxLength) {
					$output .= mb_substr($str, 0, $maxLength - $printedLength);
					$printedLength = $maxLength;
					break;
				}
	
				$output .= $str;
				$lastCharacterIsOpenBracket = (mb_substr($output, -1, 1) === '<');
	
				if ($lastCharacterIsOpenBracket) {
					$output = mb_substr($output, 0, mb_strlen($output) - 1);
				}
	
				$printedLength += mb_strlen($str);
	
				if ($tag[0] == '&') {
					// Handle the entity.
					$output .= $tag;
					$printedLength++;
				}
				else {
					// Handle the tag.
					$tagName = $match[1][0];
	
					if ($tag[1] == '/') {
						// This is a closing tag.
						$openingTag = array_pop($tags);
	
						$output .= $tag;
					}
					else if ($tag[mb_strlen($tag) - 2] == '/') {
						// Self-closing tag.
						$output .= $tag;
					}
					else {
						// Opening tag.
						$output .= $tag;
						$tags[] = $tagName;
					}
				}
	
				// Continue after the tag.
				if ($lastCharacterIsOpenBracket) {
					$position = ($tagPosition - 1) + mb_strlen($tag);
				}
				else {
					$position = $tagPosition + mb_strlen($tag);
				}
	
			}
	
			// Print any remaining text.
			if ($printedLength < $maxLength && $position < mb_strlen($html)) {
				$output .= mb_substr($html, $position, $maxLength - $printedLength);
			}
	
			$output .= $suffix;
			// Close any open tags.
			while (!empty($tags))
			{
				$output .= sprintf('</%s>', array_pop($tags));
			}
	
			$length = mb_strlen($output);
			$lastChar = mb_substr($output, ($length - 1), 1);
			$characterNumber = ord($lastChar);
	
			if ($characterNumber === 194) {
				$output = mb_substr($output, 0, mb_strlen($output) - 1);
			}
	
			$output = JString::rtrim($output);
			
			if($wholeword) {
				$last = strrpos($output, " ");
				$output = substr( $output, 0, $last ) . ' ' .$suffixChar; 
			}
			
			
			return $output;
		}
		
		
	
		public static function mb_preg_match(
			$ps_pattern,
			$ps_subject,
			&$pa_matches,
			$pn_flags = 0,
			$pn_offset = 0,
			$ps_encoding = NULL
			)
		{
			// WARNING! - All this function does is to correct offsets, nothing else:
			//(code is independent of PREG_PATTER_ORDER / PREG_SET_ORDER)
	
			if (is_null($ps_encoding)) $ps_encoding = mb_internal_encoding();
	
			$pn_offset = strlen(mb_substr($ps_subject, 0, $pn_offset, $ps_encoding));
			$ret = preg_match($ps_pattern, $ps_subject, $pa_matches, $pn_flags, $pn_offset);
	
			if ($ret && ($pn_flags & PREG_OFFSET_CAPTURE))
			{
				foreach($pa_matches as &$ha_match) {
					$ha_match[1] = mb_strlen(substr($ps_subject, 0, $ha_match[1]), $ps_encoding);
				}
			}
	
			return $ret;
		}	
	
	
	
	public static function striptags($text,$tags)
		{
			//$introtext = str_replace('<p>', ' ', $introtext);
			//$introtext = str_replace('</p>', ' ', $introtext);
			$text = strip_tags($text, $tags);
	
			return trim($text);
		}
		
		
	/**
	 * Cleans up text to be used in filter etc
	 *
	 * 
	 */
	
	
	public function clean($text) {
		return strtolower(str_replace(' ', '-', $text));
	}
	
	/**
	 * Makes text readable
	 *
	 * 
	 */
	
	
	public function readable($text, $separator="-") {
		return ucfirst(str_replace(str_split($separator), ' ', $text));
	}
	
	
	
	/**
	 * Flatten multi-dimansional array
	 * When limiting items per category
	 * 
	 */
	function array_flatten($array) {
	
	   $return = array();
	   
	   foreach ($array as $key => $value) {
	       if (is_array($value)){ $return = array_merge($return, self::array_flatten($value));}
	       else {$return[$key] = $value;}
	   }
	   return $return;
	
	}
	
	
	function get_folder_name($url) {
		
		$parts = explode('/', $url);
		return $parts[sizeof($parts)-1];
	}
	
	
	// Shuffle array
	function shuffle_assoc($list) { 
	  if (!is_array($list)) return $list; 
	
	  $keys = array_keys($list); 
	  shuffle($keys); 
	  $random = array(); 
	  foreach ($keys as $key) { 
	    $random[$key] = $list[$key]; 
	  }
	  return $random; 
	} 
	
	
	
	
	

}
