<?php
/**
 * @version		$Id: helper.php 1832 2013-01-30 13:05:12Z lefteris.kavadas $
 * @package		K2
 * @author		JoomlaWorks http://www.joomlaworks.net
 * @copyright	Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.
 * @license		GNU/GPL license: http://www.gnu.org/copyleft/gpl.html
 */

// no direct access
defined('_JEXEC') or die;


class zt_hikashop
{

	public static function getList(&$params, $format = 'html')
	{

				$cats = json_decode($params->get('hikashop_categories_limit', ''));
				//print_r($params->get('joomla_categories_categories_limit', ''));
				//$cats = json_decode('{"1":""}');
				$order = $params->get('hikashop_categories_ordering', 'name DESC');	
				$count = $params->get('hikashop_count', '5');
				
				// Cast object to an array
				$catitems = (array)$cats;
				
				// Get catids from array
				$catids = array_keys($catitems);
			
				// Count number of cats to process
				$limitcount = count($catitems);
				
				// Get view access levels for current user id
				$user = JFactory::getUser();
				$viewLevels = JAccess::getAuthorisedViewLevels(JUserHelper::getUserId($user->username));
				$access_levels = implode(",", $viewLevels);	
				
				// Link Type
				$link_type = $params->get('jcat_link_type', 'item');
				$link_fallback = $params->get('jcat_link_fallback');
				
				
				if($params->get('hikashop_content_type') =="items") {
				
					
				
				} else {
				
					
					
					// If just a single value then proceed as usual
					if($limitcount <= 1) {
				
						// Get all products from a specified category
						$db = JFactory::getDBO();
						$query	= $db->getQuery(true);
						$query->select('.product_id');
						$query->from('#__hikashop_product_category'); 
						$query->where('category_id =' . implode(',', $catids));
						$db->setQuery($query, 0);
						$products = $db->loadColumn();
						print_r($products);
						
						// If no limits on category numbers we just perform the standard query
						$db = JFactory::getDBO();
						$query	= $db->getQuery(true);
						$query->select('a.*');
						$query->from('#__hikashop_product AS a'); 
						
						if(!empty($catids)) {
							$query->where('a.product_id =' . $product);
						    $query->where('a.product_published = 1');
						}
						
						//$query->where('product_published = 1')->where("product_access in ($access_levels)");
						
						if(isset($catids[0])) {
							
							$limit = $cats->{$catids[0]};
							
							if($limit > $count) {
								$limit = $count;
							}
							
						} else {
							$limit = $count;
						}
						
						if($order =='title') {
							
							$query->order('title ASC');
							
						} elseif($order =='title_reverse') {
							
							$query->order('title DESC');
							
						} elseif($order =='random') {
						
							$query->order('RAND()');
							
						} elseif($order =='order') {
						
							$query->order('lft ASC');
						
						} elseif($order =='order_reverse') {
						
							$query->order('lft DESC');
						
						} 
			
						$db->setQuery($query, 0, $limit);
						$products = $db->loadObjectList();
						
					} else {
					
						// Get items from each category limited by number set in admin
						// To do this we need to union the selects
						// and then apply an order at the end
						
						$db = JFactory::getDbo();
						$query = $db->getQuery(true);
						
						// Loops through the catd ids and limits set
						// catid:limit
						// 42:2
					
						// We need to calculate the new total items to display
						// Check later to see if it's higher or lower than the count amount
						$total = '';
					
						foreach ($cats as $catid => $limit) {
							
							// If limit is left blank in the settings
							if($limit == "") {
								$limit = $count;
							}
							
							// Set up the union query
							${'q'.$catid} = $db->getQuery(true);
							
							// Create the select for each cat
							${'q'.$catid}
							    ->select('*')
							    ->from('#__hikashop_product')
							   ->where('product_published = 1')
							    ->where('product_id = '.$catid.'');
							   
							   // Limit the items from this category
							    ${'q'.$catid}->setLimit($limit);
							    
							    $total += $limit;
						}
								
						// Perform the base query
						// First item is a dummy
						// Then loop through the unions
						// created in the previous step
						
						$query
						    ->select('*')
						    ->from('#__hikashop_product')
						    ->where('1 = 0');
						    
						 foreach ($cats as $catid => $limit) {
						   	$query->union(${'q'.$catid});
						 }
						 
						 
						 // Bug in the Joomla dbo prevents us from being able to use $query->order
						 if($order =='title') {
						 	//$query->order('title ASC');
						 	$query .= ' ORDER BY title ASC ';
						 	
						 } elseif($order =='title_reverse') {
						 	
						 	//$query->order('title DESC');
						 	$query .= ' ORDER BY title DESC ';
						 	
						 } elseif($order =='random') {
						 
						 	//$query->order('RAND()');
						 	$query .= ' ORDER BY RAND() ';
						 	
						 } elseif($order =='order') {
						 
						 	//$query->order('lft ASC');
						 	$query .= ' ORDER BY lft ASC ';
						 
						 } elseif($order =='order_reverse') {
						 
						 	//$query->order('lft DESC');
						 	$query .= ' ORDER BY title DESC ';
						 
						 } 
						 
					
					    // If the total number of items is less than the count
					    if($total < $count) {
					    	$query .= ' LIMIT ' . $total ;
					    } else {
					    	$query .= ' LIMIT  ' . $count ;
					    }
					    
					    echo $query;
					    
					    // Set the query
					    $db->setQuery($query);	
						
						// The final array    	    	    
					    $products = $db->setQuery($query)->loadObjectList();	
								
						
					}
			
				}
			
				// Manual Links
				$manual_links = null;
				
				if($link_type =="manual") {
					$manual_links = explode(PHP_EOL, $params->get('jcat_manual_links'));
				}
				
		
				if(is_array($products)) {
				
							
					foreach ($products as $key=>$product) {
						
						// Create the new class
						$item = new stdClass();
						
						// Title
						$item->title = $product->product_name;
						$item->alias = str_replace(' ', '-', $item->title);
						
						// Description
						$item->introtext = $product->product_description;
						
						// Images
						$item->images = self::get_images($product->product_id);
						
						// First image
						$item->image = 'images/com_hikashop/upload/' . $item->images{0}->file_path;
						
						// Get all images
						$images = array();
						
						foreach ($item->images as $key => $image) {
							$images[] = 'images/com_hikashop/upload/' . $image->file_path;
						}
						
						$item->images = $images;
						
						$item->link = 'index.php?option=com_hikashop&ctrl=product&task=show&cid='.$product->product_id.'&name='.$item->alias;
												
						// Quantity
						$item->quantity = $product->product_quantity;
						$item->weight = $product->product_weight;
						$item->height = $product->product_height;
						$item->width = $product->product_width;
						$item->length = $product->product_length;
						$item->number_sales = $product->product_quantity;
						$item->code = $product->product_code;
						$item->date = $product->product_created;
						
						$item->contact = $product->product_contact;
						$item->manufacturer = $product->product_manufacturer_id;
						
						// Brand
						
						if($product->product_manufacturer_id) {
							$item->brand = self::get_category($product->product_manufacturer_id);
							$item->brand_url = 'index.php?option=com_hikashop&ctrl=category&task=listing&cid='.$product->product_manufacturer_id.'&name='.$item->brand[0]->category_alias.'&Itemid=266';
						} else {
							$item->brand = 0;
						}
						
						
						// Price
						$item->price = self::get_price($product->product_id);
						$item->currency = $item->price[0]->price_currency_id;
						$item->price = $item->price[0]->price_value;
						$item->retail_price = $product->product_msrp;
						
						$currency = self::get_currency($item->currency);
						$item->currency = $currency[0]->currency_symbol;
						
						
						// Ratings
						
						
						// Url
						$item->url = $product->product_url;
						
						// Category
						$item->category = self::get_category_id($product->product_id);
						$category = self::get_category($item->category[0]->category_id);
						$item->category = $category[0]->category_name;
						$item->catid = $category[0]->category_id;
						$item->catalias = $category[0]->category_alias;
						$item->catlink = 'index.php?option=com_hikashop&ctrl=category&task=listing&cid='.$item->catid.'&name='.$item->catalias.'&Itemid=266';
						
						$item->keywords = $product->product_keywords;
						$item->number_sales = $product->product_sales;
						
						// Meta
						$item->metadescription = $product->product_meta_description;
						
						// Featured
						$item->featured = null;
						
						$items[] = $item;
					}
					return $items;
				}
				
			}
			
		
			
			
			public static function get_images($product_id) {
				$db = JFactory::getDbo(); 
				$query = $db->getQuery(true); 
				$query->select(array('file_path', 'file_ordering')) 
				      ->from($db->quoteName('#__hikashop_file'))
					  ->where($db->quoteName('file_ref_id') . ' = '. $product_id);
				$db->setQuery($query); 
				$rows = $db->loadObjectList();
				return $rows;
			}
			
		
			
			
			public static function get_category($parent_id) {
				$db = JFactory::getDbo(); 
				$query = $db->getQuery(true); 
				$query->select(array('category_id','category_name', 'category_alias')) 
				      ->from($db->quoteName('#__hikashop_category')) 
				      ->setLimit(1)
					  ->where($db->quoteName('category_id') . ' = '. $parent_id);
				$db->setQuery($query); 
				$rows = $db->loadObjectList();
				return $rows;
			}
			
			
			public static function get_category_id($id) {
				$db = JFactory::getDbo(); 
				$query = $db->getQuery(true); 
				$query->select(array('category_id')) 
				      ->from($db->quoteName('#__hikashop_product_category')) 
				      ->setLimit(1)
					  ->where($db->quoteName('product_id') . ' = '. $id);
				$db->setQuery($query); 
				$rows = $db->loadObjectList();
				return $rows;
			}
			
			
			public static function get_price($id) {
				$db = JFactory::getDbo(); 
				$query = $db->getQuery(true); 
				$query->select(array('price_value','price_currency_id')) 
				      ->from($db->quoteName('#__hikashop_price')) 
				      ->setLimit(1)
					  ->where($db->quoteName('price_id') . ' = '. $id);
				$db->setQuery($query); 
				$rows = $db->loadObjectList();
				return $rows;
			}
			
			
			public static function get_currency($currency_id) {
				$db = JFactory::getDbo(); 
				$query = $db->getQuery(true); 
				$query->select(array('currency_code', 'currency_symbol')) 
				      ->from($db->quoteName('#__hikashop_currency'))
					  ->where($db->quoteName('currency_id') . ' = '. $currency_id);
				$db->setQuery($query); 
				$rows = $db->loadObjectList();
				return $rows;
			}
		

}
