<?php
/**
 * @package		Zen Tools
 * @subpackage	Zen Tools
 * @author		Joomla Bamboo - design@joomlabamboo.com
 * @copyright 	Copyright (c) 2013 Joomla Bamboo. All rights reserved.
 * @license		GNU General Public License version 2 or later
 * @version		1.8.5
 */

defined('_JEXEC') or die('Restricted access'); 

$class = ' zt-'.$options->theme; 
$class .= ' zt-arrow-' . $options->arrow_position;
$class .= ' zt-arrow-' . $options->arrow_style;

$title = null;

foreach($layout as $key=>$colcontent) {
	
	$element = key((array)$colcontent);
    
    if($element == 'title') {
    	$title = $colcontent;
    	$title = $layout->{$key}->title;
    	break;
    }
}

if($title == null) {
	if(isset($layout->{0}->title)) {
		$title = $layout->{0}->title;
	} else {
		echo '<p class="alert alert-warning">Warning you need to at least have the title published for this layout.</p>';
		return;
	}
}


 ?>

<div id="zentools-<?php echo $module->id;?>" class="zentools zt-accordion <?php echo $class;?> zt-item">

		<?php foreach ($list as $key => $item) { 
			
			$item_class = '';
			if($item->featured) {
				$item_class .= 'class="zt-featured"';
			}
			
			$clean_name = strtolower(str_replace(' ', '-', $item->title));
		?>
			<section id="<?php echo $clean_name;?>" <?php echo $item_class;?>>
				<<?php echo $title->class;?> class="accordion-title">
					<span class="fa fa-<?php echo $options->close_icon;?> zen-icon zen-icon-<?php echo $options->close_icon;?> zt-accordion-trigger"></span>
					<a href="#<?php echo $clean_name;?>">
						<?php echo $item->title;?>
					</a>
				</<?php echo $title->class;?>>
			
			
			<div class="zt-accordion-content">	
				<?php foreach ($columns as $column => $colwidth) { ?>
					<div class="zt-col zt-col-<?php echo $colwidth;?> zt-column-<?php echo $column + 1;?>"> 
						<?php $elements = $layout->$column;
						$count = 0;
							foreach ($elements as $type => $element) {
								$settings->count = $count;
								
								if($type !=="title") {
									$zen->loadElement($element->type, $element, $item, $settings, $zen);
								}
								$count ++;
							} ?>
						</div>
				<?php } ?>
			</div>		
		</section>
		<?php } ?>

</div>

<script>
	jQuery(document).ready(function($) {
		
		<?php if($options->open_first) { ?>
			
			$('#zentools-<?php echo $module->id;?> section:first-child .accordion-title').addClass('open').parent().addClass('open');
			$('#zentools-<?php echo $module->id;?> section:first-child .zt-accordion-content').slideDown();
			$('#zentools-<?php echo $module->id;?> section:first-child .accordion-title').find('span').addClass('fa-<?php echo $options->open_icon;?> zen-icon-<?php echo $options->open_icon;?>').removeClass('zen-icon-<?php echo $options->close_icon;?> fa-<?php echo $options->close_icon;?>')
		<?php } ?>
		
		
		
		$('#zentools-<?php echo $module->id;?> .accordion-title').click(function() {
				
			if($(this).hasClass('open')) {
				$('#zentools-<?php echo $module->id;?> .zt-accordion-content').slideUp();
				$('#zentools-<?php echo $module->id;?> .accordion-title').removeClass('open').parent().removeClass('open');
				$(this).find('span').addClass('fa-<?php echo $options->close_icon;?> zen-icon-<?php echo $options->close_icon;?>').removeClass('fa-<?php echo $options->open_icon;?> zen-icon-<?php echo $options->open_icon;?>');
			} else {
				$('#zentools-<?php echo $module->id;?> .zt-accordion-content').slideUp();
				$('#zentools-<?php echo $module->id;?> .accordion-title').removeClass('open').parent().removeClass('open');
				$(this).find('span').removeClass('fa-<?php echo $options->open_icon;?> zen-icon-<?php echo $options->open_icon;?>').addClass('fa-<?php echo $options->close_icon;?> zen-icon-<?php echo $options->close_icon;?>');
				$(this).find('span').addClass('fa-<?php echo $options->open_icon;?> zen-icon-<?php echo $options->open_icon;?>').removeClass('fa-<?php echo $options->close_icon;?> zen-icon-<?php echo $options->close_icon;?>');
				$(this).addClass('open').next('.zt-accordion-content').slideDown();
				$(this).parent().addClass('open');
			}
			
			
			<?php if($options->accordion_position) { ?>
				
					var clicked = $(this);
						setTimeout(function() {
							scroll(clicked);
					}, 600);
			
					function scroll(clicked) {
				
						var top = $(clicked).offset().top - <?php echo str_replace('px', '', $options->position_offset);?>;
				
						$('html,body').animate({
				    	    scrollTop: top},
				    	    'slow');
					}
			<?php } ?>
			
			return false;
		});
		
	});
</script>
<?php if($lightbox->enable) { $zen->loadBlock('lightbox', $module, $settings); } ?>