<?php
/**
 * @package		Zen Tools
 * @subpackage	Zen Tools
 * @author		Joomla Bamboo - design@joomlabamboo.com
 * @copyright 	Copyright (c) 2013 Joomla Bamboo. All rights reserved.
 * @license		GNU General Public License version 2 or later
 * @version		1.8.5
 */

defined('_JEXEC') or die('Restricted access'); 


$last = "";
$class = ' zt-'.$options->theme;

if($options->margin) {
	$class .= ' zt-no-margin';
}

if($options->navbar_style !=="none") {
	$class .= ' ' . $options->navbar_style;
}

$class .= ' max-cols-'.$options->maxcols;
$count = count($list);

// Make sure page on load isnt set beyond the items returned
$page_on_load = $options->page_on_load;

if($page_on_load > ($count / $options->maxcols)) {
	$page_on_load = ceil($count / $options->maxcols);
}
?>

<div id="zentools-<?php echo $module->id;?>" class="zentools zt-pagination <?php echo $class;?>">
	
	<div class="pager-list zentools-<?php echo $module->id;?>-pagination-controls">
		<!-- Pagination buttons will be generated here -->
	</div>
	<?php if($options->imagesloaded) {  $zen->loadBlock('loader', $module, $options); } ?>
	<ul class="zt-pagination-content zt-grid">
		<?php foreach ($list as $key => $item) { 
		
		$item_class = '';
		
		if($item->featured) {
			$item_class .= ' zt-featured';
		}
		?><li grid-col="1/<?php echo $options->maxcols;?>" class="mix zt-item<?php echo $item_class;?> zt-item-<?php echo $key + 1;?>">
				<?php foreach ($columns as $column => $colwidth) { ?>
					<div class="zt-col zt-col-<?php echo $colwidth;?> zt-column-<?php echo $column + 1;?>"> 
						<?php $elements = $layout->$column;
							foreach ($elements as $type => $element) {
								$settings->count = $count;
								$zen->loadElement($element->type, $element, $item, $settings, $zen);
							} ?>
						</div>
				<?php } ?>		
			</li>
		<?php } ?>
	</ul>
</div>

<?php if($lightbox->enable) { $zen->loadBlock('lightbox', $module, $settings); } ?>

<script>
	jQuery(document).ready(function($) {
	
		$('#zentools-<?php echo $module->id;?>').mixItUp({
			load: {
				page: <?php echo $page_on_load;?>
			},
			pagination: {
				limit: <?php echo $options->maxcols;?>,
				loop: true,
				pagerClass: '<?php echo $options->navbar_style;?>',
				maxPagers: <?php echo $options->maxpagers;?>,
				prevButtonHTML: '<span class="zen-icon zen-icon-chevron-left fa fa-chevron-left"></span>',
				nextButtonHTML: '<span class="zen-icon zen-icon-chevron-right fa fa-chevron-right"></span>',	
			},
			selectors: {
			         pagersWrapper: '.zentools-<?php echo $module->id;?>-pagination-controls',
			         sort: '.zentools-<?php echo $module->id;?>-sort'
			},
			animation: {
				enable: true,
				<?php if($options->easing) {?>
				easing: 'cubic-bezier(0.175, 0.885, 0.32, 1.275)',
				<?php } ?>
				effects: '<?php echo $options->effects;?> stagger(<?php echo $options->stagger_speed;?>ms)',
						staggerSequence: function(i){
							return i % <?php echo $options->maxcols;?>
						}	
			},
			callbacks: {
				onMixLoad: function(state, futureState){
					$('#zentools-<?php echo $module->id;?>').addClass('loaded');
				},
				onMixStart: function(state, futureState){
					// Need to reinstate the last item class
					$('#zentools-<?php echo $module->id;?> .pager-list').find('.page-number:last').addClass('last-item');
					
						// Force the container to maintain it's height
						var height =  $('#zentools-<?php echo $module->id;?>').height();
						$('#zentools-<?php echo $module->id;?>').css({'min-height': height});
						
					
					
				},
				onMixEnd: function(state){
					// Need to reinstate the last item class
					$('#zentools-<?php echo $module->id;?> .pager-list').find('.page-number:last').addClass('last-item');
					var height =  $('#zentools-<?php echo $module->id;?> ul').height();
					$('#zentools-<?php echo $module->id;?>').css({'min-height': height});
				}
				
			}
		});
	});
</script>

<?php if($options->imagesloaded) {
		$doc->addScript($media_path .'js/imagesloaded.pkgd.min.js'); ?>

<script>
jQuery(document).ready(function($) {
	$('#zentools-<?php echo $module->id;?>').imagesLoaded( function() {
	
	  	$('#zentools-<?php echo $module->id;?> .loading-wrap').fadeOut("normal", function() {
	  		
	  		$('#zentools-<?php echo $module->id;?> img').each(function() {
	  			var image = $(this).attr('data-src');
	  			$(this).attr('src', image);
	  		});
	  		
	  		$('#zentools-<?php echo $module->id;?> li.zt-item').fadeIn();
	  	});
	 });
});
</script>
<?php } ?>

