<?php
/**
 * @package		Zen Tools
 * @subpackage	Zen Tools
 * @author		Joomla Bamboo - design@joomlabamboo.com
 * @copyright 	Copyright (c) 2013 Joomla Bamboo. All rights reserved.
 * @license		GNU General Public License version 2 or later
 * @version		1.8.5
 */

defined('_JEXEC') or die('Restricted access'); 


$class = '';

// Create image element
if(isset($layout->{0}->image)) {
	$image = $layout->{0}->image;
}

// Disable / enable drag events
$mouse_drag = 1;
if(isset($options->mouse_drag)) {
	$mouse_drag = $options->mouse_drag;
}

$touch_drag = 1;
if(isset($options->touch_drag)) {
	$touch_drag = $options->touch_drag;
}

$layout_cols = count($columns);
?>

<div id="zentools-<?php echo $module->id;?>" class="zentools slideshow-<?php echo $module->id;?> owl-carousel <?php echo $class;?>">
	<?php foreach ($list as $key => $item) { 
	
		$item_class = '';
		if($item->featured) {
			$item_class .= ' zt-featured';
		}
		?>
		<div class="zt-item<?php echo $item_class;?> zt-item-<?php echo $key + 1;?>">
			<?php foreach ($columns as $column => $colwidth) { ?>
				<div class="zt-col zt-col-<?php echo $colwidth;?> zt-column-<?php echo $column + 1;?>"> 
					<?php $elements = $layout->$column;
						$count = 1;
						$total_elements = count((array)$elements);
						
						foreach ($elements as $type => $element) {
							$settings->count = $count;
							if($count == 2 && $layout_cols == 1) { ?>
								<div class="zt-item-container">
							<?php }
							
							$zen->loadElement($element->type, $element, $item, $settings, $zen);
							
							if($count == $total_elements && $count !==1 && $layout_cols == 1) { ?>
								</div>
							<?php } 
							$count ++;
						} ?>
					</div>
			<?php } ?>		
		</div>
	<?php } ?>
</div>

<?php if($options->counter) { ?>
<div id="zt-counter-<?php echo $module->id;?>" class="zt-counter zt-counter-<?php echo $options->theme;?>">
	<span class="zt-current"></span><span class="zt-separator">/</span><span class="zt-total"></span>
</div>
<?php } ?>

<?php if($options->pagination == "thumbs") { 
		include($block_root . '/carousel-nav.php');
	} 
?>



<?php if($lightbox->enable) { $zen->loadBlock('lightbox', $module, $settings); } ?>

<script>
	jQuery(document).ready(function($) {
	 	var sync1 = $("#zentools-<?php echo $module->id;?>");
	 	var sync2 = $("#sync2-<?php echo $module->id;?>");
	 	 
	 	sync1.owlCarousel({
	 	   singleItem : true,
	 	   baseClass : "zt-slideshow",
	 	   stopOnHover: true,
	 	   theme : "zt-<?php echo $options->theme;?>",
	 	   slideSpeed : 1000,
	 	   <?php if($options->autoheight) { ?>
	 	   autoHeight: true,
	 	     <?php } ?>
	 	   <?php if($options->pagination == "none" || $options->pagination == "thumbs") { ?>
	 	   pagination:false,
	 	   <?php } ?>
	 	   <?php if($options->pagination == "numbers") { ?>
	 	   paginationNumbers:true,
	 	    <?php } ?>
	 	   <?php if(!$mouse_drag) { ?>
	 	   	mouseDrag: false,
	 	   <?php } ?>
	 	   <?php if(!$touch_drag) { ?>
	 	    	touchDrag: false,
	 	    <?php } ?>
	 	   lazyLoad : true,
	 	    <?php if($options->effect !=="slide") { ?>
	 	      transitionStyle: "<?php echo $options->effect;?>",
	 	      <?php } ?>
	 	      <?php if($options->autoplay) { ?>
	 	        autoPlay : <?php echo $options->autoplay_speed;?>,
	 	        <?php } ?>
	 	    <?php if($options->navigation) { ?>
	 	       navigation: true,
	 	      // navigationText : false,
	 	      navigationText: ["<?php echo $options->nav_prev;?>","<?php echo $options->nav_next;?>"],
	 	       <?php } ?>
	 	    responsiveRefreshRate : 200,
	 	    
	 	    afterAction: function(el){
	              //remove class active
	              var total = $(this.$owlItems).length;
	              var current = this.$owlItems.eq(this.currentItem + 1).index();
	             
	              $('#zentools-<?php echo $module->id;?> .owl-item').removeClass('zt-visible');
	              
	              setTimeout(function() {
	              	$('#zentools-<?php echo $module->id;?> .owl-item').eq(current - 1).addClass('zt-visible');
	              	
	              }, 1000)
	              
	              if(current == -1) {
	               	current = total;
	              }
	              
	             
	               
	              $("#sync2-<?php echo $module->id;?>")
	                 .find(".owl-item")
	                 .removeClass("synced")
	                 .eq(current - 1)
	                 .addClass("synced");
	                 
	              if($("#sync2-<?php echo $module->id;?>").data("owlCarousel") !== undefined){
	                 center(current)
	              }
	                             
	              $('#zt-counter-<?php echo $module->id;?> .zt-total').text(total);
	              $('#zt-counter-<?php echo $module->id;?> .zt-current').text(current); 
	              
	              // Null the video
	              var $frame = this.$owlItems.eq(this.currentItem - 1).find('iframe');
	              var vidsrc = $frame.attr('src');
	              $frame.attr('src',''); 
	              $frame.attr('src', vidsrc);   
	 	        }
	 	  });
	 	 
	 	 <?php if($options->pagination == "thumbs") { ?>
	 	  sync2.owlCarousel({
	 	    items : <?php echo $options->largescreen_items;?>,
	 	    itemsDesktop : [<?php echo $options->largescreen;?>,<?php echo $options->largescreen_items;?>], //5 items between 1000px and 901px
	 	    itemsDesktopSmall : [<?php echo $options->mediumscreen;?>,<?php echo $options->mediumscreen_items;?>], // betweem 900px and 601px
	 	    itemsTablet: [<?php echo $options->smallscreen;?>,<?php echo $options->smallscreen_items;?>], //2 items between 600 and 0
	 	    itemsMobile : false,
	 	    pagination:false,
	 	    navigation: false,
	 	    lazyLoad : true,
	 	    responsiveRefreshRate : 100,
	 	    afterInit : function(el){
	 	      el.find(".owl-item").eq(0).addClass("synced");
	 	    }
	 	  });
	 	 
	 	  function syncPosition(el){
	 	 
	 	    var current = this.currentItem;
	 	    
	 	    $("#sync2-<?php echo $module->id;?>")
	 	      .find(".owl-item")
	 	      .removeClass("synced")
	 	      .eq(current)
	 	      .addClass("synced");
	 	     
	 	    if($("#sync2-<?php echo $module->id;?>").data("owlCarousel") !== undefined){
	 	      center(current)
	 	    }
	 	  }
	 	 
	 	  $("#sync2-<?php echo $module->id;?>").on("click", ".owl-item:not(.synced)", function(e){
	 	   e.preventDefault();
	 	    var number = $(this).data("owlItem");
	 	    sync1.trigger("owl.goTo",number);
	 	  });
	 	 
	 	  function center(number){
	 	    var sync2visible = sync2.data("owlCarousel").owl.visibleItems;
	 	    var num = number;
	 	    var found = false;
	 	    for(var i in sync2visible){
	 	      if(num === sync2visible[i]){
	 	        var found = true;
	 	      }
	 	    }
	 	 
	 	    if(found===false){
	 	      if(num>sync2visible[sync2visible.length-1]){
	 	        sync2.trigger("owl.goTo", num - sync2visible.length+2)
	 	      }else{
	 	        if(num - 1 === -1){
	 	          num = 0;
	 	        }
	 	        sync2.trigger("owl.goTo", num);
	 	      }
	 	    } else if(num === sync2visible[sync2visible.length-1]){
	 	      sync2.trigger("owl.goTo", sync2visible[1])
	 	    } else if(num === sync2visible[0]){
	 	      sync2.trigger("owl.goTo", num-1)
	 	    }
	 	    
	 	  }
	 	 <?php } ?>
	 	
	 	
		
	});
</script>
