<?php
// no direct access
defined('_JEXEC') or die;


jimport('joomla.filesystem.folder');
jimport( 'joomla.filesystem.file' );


class plgAjaxZentools2 extends JPlugin
{

	function onAjaxZentools2()
       {
       
	       	 $app = JFactory::getApplication();
			    
			 // Only use the plugin in the admin
			 if (!$app->isAdmin()) return;
			    
			 $jinput = JFactory::getApplication()->input;
			 $data 	= $jinput->get('data', '', 'RAW');
			 $value = $jinput->get('value', '', 'RAW');
			 $id = $jinput->get('id');
			 $cmd = $jinput->get('cmd', '', 'RAW');
			 $type = $jinput->get('type', '', 'RAW');
			 
			 return self::$cmd($data, $id, $type);
		}
       
       
	    /**
		* 	Checks the json file on the jb server and returns
		*	the version value
		* 	returns integer
		*/
	
       private function version_check($data, $id) {
	       $version = 'http://www.joomlabamboo.com/zentools2.json';
		   $latest = json_decode(JFile::read($version));
		   
		   return $latest->version;
       }
       
       
       
       /**
		* 	Used to check the exif data from the supplied image
		*	returns array
		* 	
		*/
		
       private function get_exif($image, $id) {
	       
		     require_once JPATH_ROOT . '/modules/mod_zentools2/includes/exif_reader.php';
		     
		     $image = str_replace('../', '/', $image);
		     $exif_data = new KEHA76_Exif_Reader();
		     $read_image =  JPATH_ROOT .$image;
			 $exif = $exif_data->getDetails($read_image);
		     return $exif;

       }
       
       
       /**
		* 	Less compiler
		*	Receives variables set in the interface
		* 	Processes them and writes the file to the media folder
		*/
       
        private function compile($data, $id, $type) {
	       
		      	require_once JPath::clean(JPATH_ROOT . '/modules/mod_zentools2/includes/libs/lessc/Less.php');
		      	
		      	// Paths
		      	$media = JPATH_ROOT . '/media/mod_zentools2/';
		      	$path = $media. 'less/zentools.less';
		      	
		      	
		      	
		      	// Variable array
		      	$data = array_filter(explode('|', $data));
		      	
		      	$variable_array = array();
		      	
		      	foreach($data as $variable => $value) {
			      	$value = explode(':', $value);
			      	$variable = $value[0];
			      	$value = $value[1];
			      	$variable_array[$variable] = $value;
			    }
			    
			    
			    // Options
				$options = array( 'compress'=>true );
				
				if($type=='custom') {
				
					// Files to compile
					$files = array();
					$output = $media. 'css/custom/zentools-'.$id.'.min.css'; 
		      		
			      	// Parse the content
			      	$parser = new Less_Parser($options);
				  	
				  	
				  	// Get the themes to parse
				  	$theme_folder = $media . 'less/custom_style/';
					$themes = JFOLDER::files($theme_folder);
					
				  	foreach($themes as $theme) {
						$file = $theme_folder . $theme;
						$parser->parseFile($file, '');
					}
					
				  	$parser->ModifyVars($variable_array);
				  	$css = $parser->getCss();
				  	JFile::write($output, $css);
		      	
		      	
		      	} else {
			      	$output = $media. 'css/zentools.min.css';
			      	
			      	// Write a generated variables file
			      	// This is done to safeguard  variables that might get overwritten by other items
			      	
			      	$generated_variables = '';
			      	$generated_variables_file = $media. '/less/variables-generated.less'; 
			      	
			      	foreach($variable_array as $variable => $value) {
				      	
				      	$generated_variables .= '@'.$variable.':'.$value.';'."\n";
				      	
			      	}
			      	
			      	JFile::write($generated_variables_file, $generated_variables);
			      	
			      	// Parse the content
			      	$parser = new Less_Parser($options);
				  	$parser->parseFile( $path, '');				  	
				  	$parser->ModifyVars($variable_array);
				  	$css = $parser->getCss();
				  	JFile::write($output, $css);
				}
    
       }
       
       
       
        /**
		* 	JS Compressor
		*	Receives variables set in the interface
		* 	Processes them and writes the file
		*/
		
       private function compress($data, $id) {
	       
	       		// Include minifier
		      	require_once JPath::clean(JPATH_ROOT . '/modules/mod_zentools2/includes/libs/jshrink/minifier.php');
		      	
				
		      	// Paths
		      	$media = JPATH_ROOT . '/media/mod_zentools2/';
		      	$path = $media. '/js/';
		      	$output = $media. '/js/zentools-'.$id.'.min.js'; 
		      	
		      
				// Get assets
		      	$assets = self::load_assets('carousel');
			  	$assets = $assets[0];
				$buffer ="";
				
				foreach ($assets as $key => $file) {
					
					if($file !=="") {
						
						$buffer .= JFile::read($media . $file) . "\n";	
					}
				}
		      	
		      	$minifiedCode = \JShrink\Minifier::minify($buffer);
	
			  	JFile::write($output, $minifiedCode);
       }
       
       
       
        /**
		* 	Gets assets required for specific layouts
		*	Duplicate of helper file
		* 	returns array of files from the xml file.
		*/
		
       public function load_assets($layout) {
		
			// Check exists
			$layout = JPATH_ROOT .'/modules/mod_zentools2/settings/layouts/'. $layout .'.xml';
			
			if (file_exists($layout)) {
			
				$assets = JFactory::getXML($layout);
				$assets = $assets->assets;
				
				$items = array();
				
				foreach ($assets as $key => $asset) {
					$items[] = $asset;	
				}
				
				return $items;
			}
		}
		
		
		
		
		 /**
		* 	Gets images from folders
		*	
		* 	returns array of images.
		*/
		
       public function get_gallery($layout) {
		
			$folders = self::get_folders();
			
			$folder_data = array();
			
			foreach($folders as $folder) {
				
				$path = JPATH_ROOT.'/images/'.$folder;
				
				// list of filetypes you want to show
				$allowed_types = '\.png$|\.gif$|\.jpg$|\.jpeg$|\.JPEG$|\.PNG$|\.GIF$|\.JPG$|\.$';
						
				// Retrieve the images			
				$images = JFolder::files($path, $filter = $allowed_types, 0, 0);
						
				$folder_data[$folder] = $images;
				
			}
			
			//$folder_data = json_decode(json_encode($folder_data));
			
			return $folder_data;
		
		}
		
		
		
	/**
		* 	Gets names of folders
		*	
		* 	returns array of images.
		*/
		
       public function get_folders() {
		
			$path		= JPATH_ROOT.'/images';
			$path = str_replace('\\', '/', $path);
			$folders	= JFolder::folders($path);
			
			return $folders;			
				 
		}
		
		
		
		 /**
		* 	Gets names of folders and subfolders
		*	
		* 	returns array of images.
		*/
		
       public function get_all_folders() {
		
			$path		= JPATH_ROOT.'/images';
			$folders	= JFolder::folders($path,'', true, true );
			
			$clean_folders = array();
			
			foreach($folders as $folder) {
				$folder = str_replace(JPATH_ROOT, '', $folder);
				$folder = str_replace('\\', '/', $folder);
				$clean_folders[] = $folder;	
				
			}
			
			return $clean_folders;			
				 
		}
		
		
		
		/**
		* 	Gets categories from selected extension
		*	
		* 	returns array of category titles and ids
		*/
		
       public function get_categories($extension) {
		
			$db = JFactory::getDBO();
			$query = 'SELECT id, title FROM #__categories WHERE published=1 and extension="'.$extension.'"';
			$db->setQuery($query);
			$results = $db->loadObjectList();
			
			return $results; 		
				 
		}
		
		
		/**
		* 	Gets categories from selected extension
		*	
		* 	returns array of category titles and ids
		*/
		
       public function get_tags() {
		
			$db = JFactory::getDBO();
			$query = 'SELECT id, title FROM #__tags WHERE published=1';
			$db->setQuery($query);
			$results = $db->loadObjectList();
			
			return $results; 		
				 
		}
		
}


?>